Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As _
        System.EventArgs) Handles MyBase.Load
        ' get the pictures...
        Try
            ' create a connection to the service...
            Dim service As New PictureService.Service()
            ' get a list of the folders...
            Dim arrFolderNames() As String
            arrFolderNames = service.GetPictureFolders
            ' go through the list and add each name...
            Dim strFolderName As String
            For Each strFolderName In arrFolderNames
                cboFolders.Items.Add(strFolderName)
            Next
        Catch ex As Exception
            HandleException(ex)
        End Try
    End Sub

    ' HandleException - handle a Web service exception...
    Private Sub HandleException(ByVal e As Exception)
        ' loop through the inner exceptions...
        Do While Not e.InnerException Is Nothing
            e = e.InnerException
        Loop
        ' report the problem...
        MessageBox.Show("An exception occurred." & e.Message)
    End Sub

    Private Sub cboFolders_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboFolders.SelectedIndexChanged
        ' what folder did we select?
        Dim folderName As String = _cboFolders.Items(cboFolders.SelectedIndex)
        ' clear the files list...
        lstFiles.Items.Clear()
        ' connect to the service again and get the files back...
        Try
            ' connect...
            Dim service As New PictureService.Service()
            ' get the files back...
            Dim pictureList() As PictureService.PictureInfo
            pictureList = service.GetPicturesInFolder(folderName)
            ' add the pictures to the list...
            Dim pictureInfo As PictureService.PictureInfo
            For Each pictureInfo In pictureList
                ' just add the name...
                lstFiles.Items.Add(New PictureItem(pictureInfo))
            Next
        Catch ex As Exception
            HandleException(ex)
        End Try

    End Sub

    Private Sub lstFiles_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstFiles.SelectedIndexChanged
        ' get the pictureitem...
        Dim item As PictureItem = lstFiles.Items(lstFiles.SelectedIndex)
        If Not item Is Nothing Then
            ' tell ie to show the picture...
            iePicture.Navigate(item.PictureInfo.Url)
        End If

    End Sub
End Class
