Imports System.Web
Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports System.IO

<WebService(Namespace := "http://tempuri.org/")> _
<WebServiceBinding(ConformsTo:=WsiProfiles.BasicProfile1_1)> _
Public Class Service
    Inherits System.Web.Services.WebService

    Public Sub Service

    End Sub

    ' PictureFolderPath - read-only property to return the picture
    ' folder...
    Public ReadOnly Property PictureFolderPath() As String
        Get
            ' get the full path of this asmx page...
            Dim strAsmxPath As String, strPicturePath As String
            strAsmxPath = My.Request.PhysicalPath.ToString()
            ' get the service path - everything up to and including
            ' the "\"
            Dim strServicePath As String = _
                strAsmxPath.Substring(0, strAsmxPath.LastIndexOf("\") + 1)
            ' append the word "Pictures" to the end of the path...
            strPicturePath = strServicePath & "Pictures"     ' return the path...
            Return strPicturePath
        End Get
    End Property

    ' PictureFolder - property to the DirectoryInfo containing
    ' the pictures...
    Public ReadOnly Property PictureFolder() As DirectoryInfo
        Get
            Return New DirectoryInfo(PictureFolderPath)
        End Get
    End Property

    ' GetPictureFolders - return an array of the picture folders...
    <WebMethod(Description:="Return an array of the picture folders")> _
    Public Function GetPictureFolders() As String()
        ' get hold of the picture folder...
        Dim pictureFolder As DirectoryInfo = Me.PictureFolder
        ' get the array of subfolders...
        Dim objPictureSubFolder() As DirectoryInfo = _
            pictureFolder.GetDirectories()
        ' create a string array to accommodate the names...
        Dim arrFolderNames(objPictureSubFolder.Length - 1) As String
        ' now, loop through the folders...
        Dim pictureSubFolder As DirectoryInfo, intIndex As Integer
        For Each pictureSubFolder In objPictureSubFolder
            ' add the name...
            arrFolderNames(intIndex) = pictureSubFolder.Name
            ' next...
            intIndex += 1
        Next
        ' finally, return the list of names...
        Return arrFolderNames
    End Function

    ' GetPicturesInFolder - return an array of pictures from the folder...
    <WebMethod(Description:="Return an array of pictures from the folder")> _
    Public Function GetPicturesInFolder(ByVal folderName _
       As String) As PictureInfo()
        ' get hold of the folder that we want...
        Dim pictureSubFolder As DirectoryInfo
        pictureSubFolder = _
                New DirectoryInfo(PictureFolderPath & "\" & folderName)
        ' we need to get the URL of the picture folder...
        Dim pictureFolderUrl As String
        pictureFolderUrl = My.Request.ServerVariables("URL")
        ' manipulate the URL to return an absolute URL to the Pictures folder
        pictureFolderUrl = "http://" & _
            My.Request.ServerVariables("SERVER_NAME") & ":" & _
            My.Request.ServerVariables("SERVER_PORT") & "/" & _
            pictureFolderUrl.Substring(0, pictureFolderUrl.LastIndexOf("/") + 1) & _
            "Pictures"
        ' get the list of files in the subfolder...
        Dim pictureFiles() As FileInfo = pictureSubFolder.GetFiles
        ' create somewhere to put the picture infos...
        Dim pictureList(pictureFiles.Length - 1) As PictureInfo
        ' loop through each picture...
        Dim pictureFile As FileInfo, intIndex As Integer
        For Each pictureFile In pictureFiles
            ' create a new pictureinfo object...
            Dim pictureInfo As New PictureInfo()
            pictureInfo.Name = pictureFile.Name
            pictureInfo.FolderName = folderName
            pictureInfo.Url = pictureFolderUrl & "/" & _
            folderName & "/" & pictureFile.Name
            pictureInfo.FileSize = pictureFile.Length
            pictureInfo.FileDate = pictureFile.LastWriteTime
            pictureInfo.ImageFormat = _
            pictureFile.Extension.Substring(1).ToUpper
            ' add it to the array...
            pictureList(intIndex) = pictureInfo
            intIndex += 1
        Next
        ' return the list of pictures...
        Return pictureList
    End Function

End Class
